// 
//

#include "stdafx.h"
#include "..\common\WebUtil.h"
#include "chx.h"
#include "string.h"

int QueryValueString( char* pszSrc, char* pszKey, char* pszOutStr, int nOutStrLen )
{

	int	ii;
	char* value = strstr( pszSrc, pszKey);

	if( NULL == value )
		return FALSE;
	
	char* tmp = value;
	while( *tmp++ != '=' );

	if( nOutStrLen == 0 )
	{
		for(ii = 0; *tmp != '&' && *tmp != '\0'; ii++, tmp++ );
		return ii;
	}

	for(ii = 0; *tmp != '&' && *tmp != '\0' && ii < nOutStrLen; ii++ )
	{
		pszOutStr[ii] = *tmp++;
	}
	pszOutStr[ii] = '\0';
	
	return ii;
}

int GetQueryValueInt(char* pszSrc, char* pszKey)
{
	char szOutInt[64];
	if( QueryValueString(pszSrc, pszKey, szOutInt, 64) )
		return atoi(szOutInt);
	else 
		return 0;

}

int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	DWORD dwMX = 0, dwMY = 0, dwMouse = 1;

	if( 0 == strcmp( pEnv->GetValue("REQUEST_METHOD"), "GET" ) )
	{
		// ----------------------------------------------------------
		// mouse click
		// ----------------------------------------------------------
		char* pszQueryString = pEnv->GetValue("QUERY_STRING");

		if( pszQueryString == NULL )
			return 0;

		dwMX = GetQueryValueInt(pszQueryString, "mouse_x") * (0xFFFF / GetSystemMetrics(SM_CXSCREEN));
		dwMY = GetQueryValueInt(pszQueryString, "mouse_y") * (0xFFFF / GetSystemMetrics(SM_CYSCREEN));

#ifdef _WIN32_WCE_EMULATION
		//G~[^ł̓̏ꍇ
		//PC1024*768̉ʃTCY̏ꍇ
		dwMX = dwMX / 1024 * GetSystemMetrics(SM_CXSCREEN);
		dwMY = dwMY /  768 * GetSystemMetrics(SM_CYSCREEN);
		// Ƃ
#endif
		dwMouse = GetQueryValueInt(pszQueryString, "mouse_which");

		switch( dwMouse )
		{
		case 1:
			mouse_event(MOUSEEVENTF_MOVE | MOUSEEVENTF_ABSOLUTE, dwMX, dwMY, 0, 0);
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			break;

		case 2:
			mouse_event(MOUSEEVENTF_MOVE | MOUSEEVENTF_ABSOLUTE, dwMX, dwMY, 0, 0);
			mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
			mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
			break;

		case 3:
			mouse_event(MOUSEEVENTF_MOVE | MOUSEEVENTF_ABSOLUTE, dwMX, dwMY, 0, 0);
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			Sleep(100);
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			break;
		}
	}
	else
	{
		// ----------------------------------------------------------
		// string send
		// ----------------------------------------------------------
		char* pszQueryString;
		char* pszOutStr = NULL;
		char* pszText = NULL;
		char  szCRLF[] = "\r\n";
		DWORD dwLen;
		HANDLE hMem = NULL;

		pszQueryString = (char*)pBody->GetBuffer();
		
		dwLen = QueryValueString( pszQueryString, "multi_text", pszOutStr, 0 );
		pszText = new char[dwLen+3];	// add NULL space
		memset(pszText, 0, dwLen+3);
		QueryValueString( pszQueryString, "multi_text", pszText, dwLen );
		UnEscape(pszText);

		if( GetQueryValueInt( pszQueryString, "enter" ) )
		{
			strcat(pszText, szCRLF);
		}
			
		hMem = LocalAlloc(LPTR, sizeof(WCHAR) * (dwLen + 1));
		MultiByteToWideChar(CP_ACP, 0, pszText, -1, (WCHAR *)hMem, dwLen);

		if(!OpenClipboard(NULL))
		{
			delete[] pszText;
			LocalFree(hMem);
			return 0;
		}

		EmptyClipboard();
		SetClipboardData(CF_UNICODETEXT, hMem);
		CloseClipboard();

		keybd_event(VK_CONTROL, 0, 0, 0);
		keybd_event('V', 0, 0, 0);
		keybd_event('V', 0, KEYEVENTF_KEYUP, 0);
		keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
		delete[] pszText;
		// don't free hMem. system will free.
		
	}

	char* pszPathInfo = pEnv->GetValue("PATH_INFO");
	if( (pszPathInfo == NULL) || (*pszPathInfo == '\0') )
	{
		pRes->Add("Content-Type: text/html\r\n\r\n");
		pRes->Add("Error: No Pathinfo.\n");
		return pRes->GetLength();
	}

	pRes->Add("Location: ");
	pRes->Add(pszPathInfo);
	pRes->Add("\r\n\r\n");

	Sleep(1000); // Windows̓҂

	return pRes->GetLength();
}


//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}
